/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import com.ibm.etools.c.CClassifier;
import com.ibm.etools.c.CDerived;
import com.ibm.etools.c.CField;
import com.ibm.etools.c.CPackage;
import com.ibm.etools.c.CSourceText;
import com.ibm.etools.c.CStructured;
import com.ibm.etools.c.source.CBlock;
import com.ibm.etools.tdlang.TDLangClassifier;
import com.ibm.etools.tdlang.TDLangPackage;
import com.ibm.etools.typedescriptor.InstanceTDBase;
import com.ibm.etools.typedescriptor.TypeDescriptorPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Field</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link com.ibm.etools.c.impl.CFieldImpl#getInitializer <em>Initializer</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class CFieldImpl extends CStructuralFeatureImpl implements CField {
    /**
     * The cached value of the '{@link #getInitializer() <em>Initializer</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getInitializer()
     * @generated @ordered
     */
    protected CBlock initializer = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CFieldImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return CPackage.eINSTANCE.getCField();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CBlock getInitializer() {
        if (initializer != null && initializer.eIsProxy()) {
            CBlock oldInitializer = initializer;
            initializer = (CBlock) eResolveProxy((InternalEObject) initializer);
            if (initializer != oldInitializer) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, CPackage.CFIELD__INITIALIZER, oldInitializer, initializer));
            }
        }
        return initializer;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CBlock basicGetInitializer() {
        return initializer;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setInitializer(CBlock newInitializer) {
        CBlock oldInitializer = initializer;
        initializer = newInitializer;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, CPackage.CFIELD__INITIALIZER, oldInitializer, initializer));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CFIELD__TD_LANG_SHARED_TYPE:
                if (tdLangSharedType != null)
                    msgs = ((InternalEObject) tdLangSharedType).eInverseRemove(this, TDLangPackage.TD_LANG_CLASSIFIER__TD_LANG_TYPED_ELEMENT, TDLangClassifier.class, msgs);
                return basicSetTdLangSharedType((TDLangClassifier) otherEnd, msgs);
            case CPackage.CFIELD__INSTANCE_TD_BASE:
                if (instanceTDBase != null)
                    msgs = ((InternalEObject) instanceTDBase).eInverseRemove(this, TypeDescriptorPackage.INSTANCE_TD_BASE__LANGUAGE_INSTANCE, InstanceTDBase.class, msgs);
                return basicSetInstanceTDBase((InstanceTDBase) otherEnd, msgs);
            case CPackage.CFIELD__CONTAINS:
                if (contains != null)
                    msgs = ((InternalEObject) contains).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CPackage.CFIELD__CONTAINS, null, msgs);
                return basicSetContains((CDerived) otherEnd, msgs);
            case CPackage.CFIELD__CONTAINER:
                if (eContainer != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return eBasicSetContainer(otherEnd, CPackage.CFIELD__CONTAINER, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CFIELD__TD_LANG_SHARED_TYPE:
                return basicSetTdLangSharedType(null, msgs);
            case CPackage.CFIELD__INSTANCE_TD_BASE:
                return basicUnsetInstanceTDBase(msgs);
            case CPackage.CFIELD__CONTAINS:
                return basicSetContains(null, msgs);
            case CPackage.CFIELD__CONTAINER:
                return eBasicSetContainer(null, CPackage.CFIELD__CONTAINER, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
        if (eContainerFeatureID >= 0) {
            switch (eContainerFeatureID) {
            case CPackage.CFIELD__CONTAINER:
                return ((InternalEObject) eContainer).eInverseRemove(this, CPackage.CSTRUCTURED__CONTAINS, CStructured.class, msgs);
            default:
                return eDynamicBasicRemoveFromContainer(msgs);
            }
        }
        return ((InternalEObject) eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CFIELD__NAME:
            return getName();
        case CPackage.CFIELD__TD_LANG_SHARED_TYPE:
            if (resolve)
                return getTdLangSharedType();
            return basicGetTdLangSharedType();
        case CPackage.CFIELD__INSTANCE_TD_BASE:
            if (resolve)
                return getInstanceTDBase();
            return basicGetInstanceTDBase();
        case CPackage.CFIELD__TYPE:
            if (resolve)
                return getType();
            return basicGetType();
        case CPackage.CFIELD__CONTAINS:
            return getContains();
        case CPackage.CFIELD__SOURCE:
            if (resolve)
                return getSource();
            return basicGetSource();
        case CPackage.CFIELD__CONTAINER:
            return getContainer();
        case CPackage.CFIELD__INITIALIZER:
            if (resolve)
                return getInitializer();
            return basicGetInitializer();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CFIELD__NAME:
            setName((String) newValue);
            return;
        case CPackage.CFIELD__TD_LANG_SHARED_TYPE:
            setTdLangSharedType((TDLangClassifier) newValue);
            return;
        case CPackage.CFIELD__INSTANCE_TD_BASE:
            setInstanceTDBase((InstanceTDBase) newValue);
            return;
        case CPackage.CFIELD__TYPE:
            setType((CClassifier) newValue);
            return;
        case CPackage.CFIELD__CONTAINS:
            setContains((CDerived) newValue);
            return;
        case CPackage.CFIELD__SOURCE:
            setSource((CSourceText) newValue);
            return;
        case CPackage.CFIELD__CONTAINER:
            setContainer((CStructured) newValue);
            return;
        case CPackage.CFIELD__INITIALIZER:
            setInitializer((CBlock) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CFIELD__NAME:
            unsetName();
            return;
        case CPackage.CFIELD__TD_LANG_SHARED_TYPE:
            setTdLangSharedType((TDLangClassifier) null);
            return;
        case CPackage.CFIELD__INSTANCE_TD_BASE:
            unsetInstanceTDBase();
            return;
        case CPackage.CFIELD__TYPE:
            setType((CClassifier) null);
            return;
        case CPackage.CFIELD__CONTAINS:
            setContains((CDerived) null);
            return;
        case CPackage.CFIELD__SOURCE:
            setSource((CSourceText) null);
            return;
        case CPackage.CFIELD__CONTAINER:
            setContainer((CStructured) null);
            return;
        case CPackage.CFIELD__INITIALIZER:
            setInitializer((CBlock) null);
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CFIELD__NAME:
            return isSetName();
        case CPackage.CFIELD__TD_LANG_SHARED_TYPE:
            return tdLangSharedType != null;
        case CPackage.CFIELD__INSTANCE_TD_BASE:
            return isSetInstanceTDBase();
        case CPackage.CFIELD__TYPE:
            return type != null;
        case CPackage.CFIELD__CONTAINS:
            return contains != null;
        case CPackage.CFIELD__SOURCE:
            return source != null;
        case CPackage.CFIELD__CONTAINER:
            return getContainer() != null;
        case CPackage.CFIELD__INITIALIZER:
            return initializer != null;
        }
        return eDynamicIsSet(eFeature);
    }

} //CFieldImpl
