/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import com.ibm.etools.c.CArray;
import com.ibm.etools.c.CBehavioralFeature;
import com.ibm.etools.c.CClassifier;
import com.ibm.etools.c.CDatatype;
import com.ibm.etools.c.CDerivableType;
import com.ibm.etools.c.CDerived;
import com.ibm.etools.c.CEnumerator;
import com.ibm.etools.c.CFactory;
import com.ibm.etools.c.CField;
import com.ibm.etools.c.CFunction;
import com.ibm.etools.c.CInitializer;
import com.ibm.etools.c.CPackage;
import com.ibm.etools.c.CParameter;
import com.ibm.etools.c.CPointer;
import com.ibm.etools.c.CSourceText;
import com.ibm.etools.c.CStruct;
import com.ibm.etools.c.CStructuralFeature;
import com.ibm.etools.c.CStructureContents;
import com.ibm.etools.c.CStructured;
import com.ibm.etools.c.CTypedElement;
import com.ibm.etools.c.CTypedef;
import com.ibm.etools.c.CUnion;
import com.ibm.etools.c.datatypes.DatatypesPackage;
import com.ibm.etools.c.datatypes.impl.DatatypesPackageImpl;
import com.ibm.etools.c.source.SourcePackage;
import com.ibm.etools.c.source.impl.SourcePackageImpl;
import com.ibm.etools.tdlang.TDLangPackage;
import com.ibm.etools.tdlang.impl.TDLangPackageImpl;
import com.ibm.etools.typedescriptor.TypeDescriptorPackage;
import com.ibm.etools.typedescriptor.impl.TypeDescriptorPackageImpl;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Package </b>. <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class CPackageImpl extends EPackageImpl implements CPackage {
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cClassifierEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cStructuredEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cStructEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cUnionEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cBehavioralFeatureEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cTypedElementEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cStructuralFeatureEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cParameterEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cDatatypeEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cTypedefEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cDerivedEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cArrayEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cPointerEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cEnumeratorEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cFieldEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cFunctionEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cInitializerEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cDerivableTypeEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cStructureContentsEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cSourceTextEClass = null;

    /**
     * Creates an instance of the model <b>Package </b>, registered with
     * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry}by the
     * package package URI value.
     * <p>
     * Note: the correct way to create the package is via the static factory
     * method {@link #init init()}, which also performs initialization of the
     * package, or returns the registered package, if one already exists. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.emf.ecore.EPackage.Registry
     * @see com.ibm.etools.c.CPackage#eNS_URI
     * @see #init()
     * @generated
     */
    private CPackageImpl() {
        super(eNS_URI, CFactory.eINSTANCE);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private static boolean isInited = false;

    /**
     * Creates, registers, and initializes the <b>Package </b> for this model,
     * and for any others upon which it depends. Simple dependencies are
     * satisfied by calling this method on all dependent packages before doing
     * anything else. This method drives initialization for interdependent
     * packages directly, in parallel with this package, itself.
     * <p>
     * Of this package and its interdependencies, all packages which have not
     * yet been registered by their URI values are first created and registered.
     * The packages are then initialized in two steps: meta-model objects for
     * all of the packages are created before any are initialized, since one
     * package's meta-model objects may refer to those of another.
     * <p>
     * Invocation of this method will not affect any packages that have already
     * been initialized. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #eNS_URI
     * @see #createPackageContents()
     * @see #initializePackageContents()
     * @generated
     */
    public static CPackage init() {
        if (isInited)
            return (CPackage) EPackage.Registry.INSTANCE.get(CPackage.eNS_URI);

        // Obtain or create and register package.
        CPackageImpl theCPackage = (CPackageImpl) (EPackage.Registry.INSTANCE.get(eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(eNS_URI) : new CPackageImpl());

        isInited = true;

        // Obtain or create and register interdependencies
        DatatypesPackageImpl theDatatypesPackage = (DatatypesPackageImpl) (EPackage.Registry.INSTANCE.get(DatatypesPackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE
                .get(DatatypesPackage.eNS_URI) : DatatypesPackageImpl.eINSTANCE);
        SourcePackageImpl theSourcePackage = (SourcePackageImpl) (EPackage.Registry.INSTANCE.get(SourcePackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(SourcePackage.eNS_URI)
                : SourcePackageImpl.eINSTANCE);
        TDLangPackageImpl theTdlangPackage = (TDLangPackageImpl) (EPackage.Registry.INSTANCE.get(TDLangPackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(TDLangPackage.eNS_URI)
                : TDLangPackageImpl.eINSTANCE);
        TypeDescriptorPackageImpl theTypedescriptorPackage = (TypeDescriptorPackageImpl) (EPackage.Registry.INSTANCE.get(TypeDescriptorPackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE
                .get(TypeDescriptorPackage.eNS_URI)
                : TypeDescriptorPackageImpl.eINSTANCE);

        // Step 1: create meta-model objects
        theCPackage.createPackageContents();
        theDatatypesPackage.createPackageContents();
        theSourcePackage.createPackageContents();
        theTdlangPackage.createPackageContents();
        theTypedescriptorPackage.createPackageContents();

        // Step 2: complete initialization
        theCPackage.initializePackageContents();
        theDatatypesPackage.initializePackageContents();
        theSourcePackage.initializePackageContents();
        theTdlangPackage.initializePackageContents();
        theTypedescriptorPackage.initializePackageContents();

        return theCPackage;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCClassifier() {
        return cClassifierEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCStructured() {
        return cStructuredEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getCStructured_Contains() {
        return (EReference) cStructuredEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCStruct() {
        return cStructEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCUnion() {
        return cUnionEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCBehavioralFeature() {
        return cBehavioralFeatureEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EAttribute getCBehavioralFeature_Name() {
        return (EAttribute) cBehavioralFeatureEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getCBehavioralFeature_Parameter() {
        return (EReference) cBehavioralFeatureEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCTypedElement() {
        return cTypedElementEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getCTypedElement_Type() {
        return (EReference) cTypedElementEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getCTypedElement_Contains() {
        return (EReference) cTypedElementEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getCTypedElement_Source() {
        return (EReference) cTypedElementEClass.getEStructuralFeatures().get(2);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCStructuralFeature() {
        return cStructuralFeatureEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCParameter() {
        return cParameterEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EAttribute getCParameter_Direction() {
        return (EAttribute) cParameterEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getCParameter_BehavioralFeature() {
        return (EReference) cParameterEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCDatatype() {
        return cDatatypeEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCTypedef() {
        return cTypedefEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCDerived() {
        return cDerivedEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getCDerived_Derives() {
        return (EReference) cDerivedEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getCDerived_Container() {
        return (EReference) cDerivedEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCArray() {
        return cArrayEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EAttribute getCArray_Dimension() {
        return (EAttribute) cArrayEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCPointer() {
        return cPointerEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCEnumerator() {
        return cEnumeratorEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EAttribute getCEnumerator_Value() {
        return (EAttribute) cEnumeratorEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EAttribute getCEnumerator_Name() {
        return (EAttribute) cEnumeratorEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getCEnumerator_Enumeration() {
        return (EReference) cEnumeratorEClass.getEStructuralFeatures().get(2);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCField() {
        return cFieldEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getCField_Initializer() {
        return (EReference) cFieldEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCFunction() {
        return cFunctionEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EAttribute getCFunction_IsVarArg() {
        return (EAttribute) cFunctionEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getCFunction_Source() {
        return (EReference) cFunctionEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCInitializer() {
        return cInitializerEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getCInitializer_Source() {
        return (EReference) cInitializerEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCDerivableType() {
        return cDerivableTypeEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCStructureContents() {
        return cStructureContentsEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getCStructureContents_Container() {
        return (EReference) cStructureContentsEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCSourceText() {
        return cSourceTextEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EAttribute getCSourceText_Source() {
        return (EAttribute) cSourceTextEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EAttribute getCSourceText_FileName() {
        return (EAttribute) cSourceTextEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CFactory getCFactory() {
        return (CFactory) getEFactoryInstance();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private boolean isCreated = false;

    /**
     * Creates the meta-model objects for the package. This method is guarded to
     * have no affect on any invocation but its first. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void createPackageContents() {
        if (isCreated)
            return;
        isCreated = true;

        // Create classes and their features
        cClassifierEClass = createEClass(CCLASSIFIER);

        cStructuredEClass = createEClass(CSTRUCTURED);
        createEReference(cStructuredEClass, CSTRUCTURED__CONTAINS);

        cStructEClass = createEClass(CSTRUCT);

        cUnionEClass = createEClass(CUNION);

        cBehavioralFeatureEClass = createEClass(CBEHAVIORAL_FEATURE);
        createEAttribute(cBehavioralFeatureEClass, CBEHAVIORAL_FEATURE__NAME);
        createEReference(cBehavioralFeatureEClass, CBEHAVIORAL_FEATURE__PARAMETER);

        cTypedElementEClass = createEClass(CTYPED_ELEMENT);
        createEReference(cTypedElementEClass, CTYPED_ELEMENT__TYPE);
        createEReference(cTypedElementEClass, CTYPED_ELEMENT__CONTAINS);
        createEReference(cTypedElementEClass, CTYPED_ELEMENT__SOURCE);

        cStructuralFeatureEClass = createEClass(CSTRUCTURAL_FEATURE);

        cParameterEClass = createEClass(CPARAMETER);
        createEAttribute(cParameterEClass, CPARAMETER__DIRECTION);
        createEReference(cParameterEClass, CPARAMETER__BEHAVIORAL_FEATURE);

        cDatatypeEClass = createEClass(CDATATYPE);

        cTypedefEClass = createEClass(CTYPEDEF);

        cDerivedEClass = createEClass(CDERIVED);
        createEReference(cDerivedEClass, CDERIVED__DERIVES);
        createEReference(cDerivedEClass, CDERIVED__CONTAINER);

        cArrayEClass = createEClass(CARRAY);
        createEAttribute(cArrayEClass, CARRAY__DIMENSION);

        cPointerEClass = createEClass(CPOINTER);

        cEnumeratorEClass = createEClass(CENUMERATOR);
        createEAttribute(cEnumeratorEClass, CENUMERATOR__VALUE);
        createEAttribute(cEnumeratorEClass, CENUMERATOR__NAME);
        createEReference(cEnumeratorEClass, CENUMERATOR__ENUMERATION);

        cFieldEClass = createEClass(CFIELD);
        createEReference(cFieldEClass, CFIELD__INITIALIZER);

        cFunctionEClass = createEClass(CFUNCTION);
        createEAttribute(cFunctionEClass, CFUNCTION__IS_VAR_ARG);
        createEReference(cFunctionEClass, CFUNCTION__SOURCE);

        cInitializerEClass = createEClass(CINITIALIZER);
        createEReference(cInitializerEClass, CINITIALIZER__SOURCE);

        cDerivableTypeEClass = createEClass(CDERIVABLE_TYPE);

        cStructureContentsEClass = createEClass(CSTRUCTURE_CONTENTS);
        createEReference(cStructureContentsEClass, CSTRUCTURE_CONTENTS__CONTAINER);

        cSourceTextEClass = createEClass(CSOURCE_TEXT);
        createEAttribute(cSourceTextEClass, CSOURCE_TEXT__SOURCE);
        createEAttribute(cSourceTextEClass, CSOURCE_TEXT__FILE_NAME);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private boolean isInitialized = false;

    /**
     * Complete the initialization of the package and its meta-model. This
     * method is guarded to have no affect on any invocation but its first. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void initializePackageContents() {
        if (isInitialized)
            return;
        isInitialized = true;

        // Initialize package
        setName(eNAME);
        setNsPrefix(eNS_PREFIX);
        setNsURI(eNS_URI);

        // Obtain other dependent packages
        DatatypesPackageImpl theDatatypesPackage = (DatatypesPackageImpl) EPackage.Registry.INSTANCE.getEPackage(DatatypesPackage.eNS_URI);
        SourcePackageImpl theSourcePackage = (SourcePackageImpl) EPackage.Registry.INSTANCE.getEPackage(SourcePackage.eNS_URI);
        TDLangPackageImpl theTdlangPackage = (TDLangPackageImpl) EPackage.Registry.INSTANCE.getEPackage(TDLangPackage.eNS_URI);

        // Add subpackages
        getESubpackages().add(theDatatypesPackage);
        getESubpackages().add(theSourcePackage);

        // Add supertypes to classes
        cClassifierEClass.getESuperTypes().add(theTdlangPackage.getTDLangClassifier());
        cStructuredEClass.getESuperTypes().add(theTdlangPackage.getTDLangComposedType());
        cStructuredEClass.getESuperTypes().add(this.getCClassifier());
        cStructuredEClass.getESuperTypes().add(this.getCStructureContents());
        cStructuredEClass.getESuperTypes().add(this.getCDerivableType());
        cStructEClass.getESuperTypes().add(this.getCStructured());
        cUnionEClass.getESuperTypes().add(this.getCStructured());
        cTypedElementEClass.getESuperTypes().add(theTdlangPackage.getTDLangElement());
        cStructuralFeatureEClass.getESuperTypes().add(this.getCTypedElement());
        cStructuralFeatureEClass.getESuperTypes().add(this.getCStructureContents());
        cParameterEClass.getESuperTypes().add(this.getCTypedElement());
        cDatatypeEClass.getESuperTypes().add(this.getCClassifier());
        cDatatypeEClass.getESuperTypes().add(this.getCDerivableType());
        cTypedefEClass.getESuperTypes().add(this.getCDerived());
        cDerivedEClass.getESuperTypes().add(this.getCClassifier());
        cDerivedEClass.getESuperTypes().add(this.getCDerivableType());
        cArrayEClass.getESuperTypes().add(this.getCDerived());
        cPointerEClass.getESuperTypes().add(this.getCDerived());
        cEnumeratorEClass.getESuperTypes().add(this.getCInitializer());
        cFieldEClass.getESuperTypes().add(this.getCStructuralFeature());
        cFunctionEClass.getESuperTypes().add(this.getCBehavioralFeature());
        cFunctionEClass.getESuperTypes().add(this.getCDerivableType());

        // Initialize classes and features; add operations and parameters
        initEClass(cClassifierEClass, CClassifier.class, "CClassifier", IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cStructuredEClass, CStructured.class, "CStructured", IS_ABSTRACT, !IS_INTERFACE);
        initEReference(getCStructured_Contains(), this.getCStructureContents(), this.getCStructureContents_Container(), "contains", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
                IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED);

        initEClass(cStructEClass, CStruct.class, "CStruct", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cUnionEClass, CUnion.class, "CUnion", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cBehavioralFeatureEClass, CBehavioralFeature.class, "CBehavioralFeature", IS_ABSTRACT, !IS_INTERFACE);
        initEAttribute(getCBehavioralFeature_Name(), ecorePackage.getEString(), "name", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED);
        initEReference(getCBehavioralFeature_Parameter(), this.getCParameter(), this.getCParameter_BehavioralFeature(), "parameter", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
                IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED);

        initEClass(cTypedElementEClass, CTypedElement.class, "CTypedElement", IS_ABSTRACT, !IS_INTERFACE);
        initEReference(getCTypedElement_Type(), this.getCClassifier(), null, "type", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
                IS_UNIQUE, !IS_DERIVED);
        initEReference(getCTypedElement_Contains(), this.getCDerived(), this.getCDerived_Container(), "contains", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
                !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED);
        initEReference(getCTypedElement_Source(), this.getCSourceText(), null, "source", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
                IS_UNIQUE, !IS_DERIVED);

        initEClass(cStructuralFeatureEClass, CStructuralFeature.class, "CStructuralFeature", IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cParameterEClass, CParameter.class, "CParameter", !IS_ABSTRACT, !IS_INTERFACE);
        initEAttribute(getCParameter_Direction(), theDatatypesPackage.getCDirectionKind(), "direction", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
                !IS_DERIVED);
        initEReference(getCParameter_BehavioralFeature(), this.getCBehavioralFeature(), this.getCBehavioralFeature_Parameter(), "behavioralFeature", null, 0, 1, IS_TRANSIENT, !IS_VOLATILE,
                IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED);

        initEClass(cDatatypeEClass, CDatatype.class, "CDatatype", IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cTypedefEClass, CTypedef.class, "CTypedef", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cDerivedEClass, CDerived.class, "CDerived", IS_ABSTRACT, !IS_INTERFACE);
        initEReference(getCDerived_Derives(), this.getCDerivableType(), null, "derives", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
                IS_UNIQUE, !IS_DERIVED);
        initEReference(getCDerived_Container(), this.getCTypedElement(), this.getCTypedElement_Contains(), "container", null, 0, 1, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
                !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED);

        initEClass(cArrayEClass, CArray.class, "CArray", !IS_ABSTRACT, !IS_INTERFACE);
        initEAttribute(getCArray_Dimension(), ecorePackage.getEIntegerObject(), "dimension", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED);

        initEClass(cPointerEClass, CPointer.class, "CPointer", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cEnumeratorEClass, CEnumerator.class, "CEnumerator", !IS_ABSTRACT, !IS_INTERFACE);
        initEAttribute(getCEnumerator_Value(), ecorePackage.getEIntegerObject(), "value", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED);
        initEAttribute(getCEnumerator_Name(), ecorePackage.getEString(), "name", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED);
        initEReference(getCEnumerator_Enumeration(), theDatatypesPackage.getCEnumeration(), theDatatypesPackage.getCEnumeration_Enumerator(), "enumeration", null, 0, 1, IS_TRANSIENT, !IS_VOLATILE,
                IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED);

        initEClass(cFieldEClass, CField.class, "CField", !IS_ABSTRACT, !IS_INTERFACE);
        initEReference(getCField_Initializer(), theSourcePackage.getCBlock(), null, "initializer", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
                !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED);

        initEClass(cFunctionEClass, CFunction.class, "CFunction", !IS_ABSTRACT, !IS_INTERFACE);
        initEAttribute(getCFunction_IsVarArg(), ecorePackage.getEBooleanObject(), "isVarArg", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED);
        initEReference(getCFunction_Source(), theSourcePackage.getCBlock(), null, "source", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
                IS_UNIQUE, !IS_DERIVED);

        initEClass(cInitializerEClass, CInitializer.class, "CInitializer", !IS_ABSTRACT, !IS_INTERFACE);
        initEReference(getCInitializer_Source(), theSourcePackage.getCBlock(), null, "source", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
                !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED);

        initEClass(cDerivableTypeEClass, CDerivableType.class, "CDerivableType", IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cStructureContentsEClass, CStructureContents.class, "CStructureContents", IS_ABSTRACT, !IS_INTERFACE);
        initEReference(getCStructureContents_Container(), this.getCStructured(), this.getCStructured_Contains(), "container", null, 0, 1, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
                !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED);

        initEClass(cSourceTextEClass, CSourceText.class, "CSourceText", !IS_ABSTRACT, !IS_INTERFACE);
        initEAttribute(getCSourceText_Source(), ecorePackage.getEString(), "source", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED);
        initEAttribute(getCSourceText_FileName(), ecorePackage.getEString(), "fileName", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED);

        // Create resource
        createResource(eNS_URI);
    }
} //CPackageImpl
